{ F_Lang.pas

  Autor: (c) Jose Maria Gias
         sigekom@arrakis.es   04/19/1999
         http://www.arrakis.es/~sigecom

  Freeware  F_Lang.Pas

  Commentary un English and Spanish

  English
  ------------------------------------------------------------------------------
  This Unit, it contains the necessary functions to obtain the @@strings of the
  components of an Form and to write them in a table in the language field
  indicated. For defect table will be called GLang.Dbf and will be kept in the
  directory in which take-off the application, but we can incorporate it into an
  Alias instead of indicating to you a directory.

  In principle this preparation for Spanish, Italian, English, German, French and
  Portuguese, but enough with adding or erasing language fields in table so that
  it is adapted to our needs.

  Table by defect is .Dbf, but is wished enough with indicating a  table
  with extension .Db so that it will be Paradox.

  To generate initial table one must to call to the procedure 'DbfStringComponen
  an alone time, and automatically will create table that we indicate to you in
  the language elected. If we indicate 'All' will fill all the fields. There is
  no limit of quantity of form incorporated to table, enough with calling to this
  procedure once by each created Form and will add the data of the same.

  Also it incorporates the necessary functions to recover the stored String
  in table and to return them to our Form in the language that we indicate to
  you. For this enough with calling to the procedure 'LangDbfComponent'

  As miscellany is included the function of recording the String in a file .Ini

Examples of call:
--------------------------------------------------------------------------------
// Call to add the data in GLang.dbf
procedure TForm1.Button2Click(Sender: TObject);
var
 Dir : String;
begin

 Dir := ExtractFilePath(ExpandFileName('Demo1.Exe'));
 if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';

 Table1.DatabaseName := Dir;
 Table1.TableName    := 'Lang.Dbf';
 ExisteTabla(Table1, Dir);

 Table1.Close;

 // To capture the string of the components
 DbfStringComponent(Table1, // Data Table
                    Form1,  // Form of where they are captured the string
                    Dir,    // DatabaseName, o directory of de application
                    'ALL',  // Languages that will fill in table. SP,IT,EN,DE,FR,PO,(ALL)
                    True,   // To write the Strings in White
                    False;) // ReWrite existing String in table

 // As of here it can be called to the procedure as many times as Form they may
 // have been created with precedence, or well to create them, to call to the
 // function and to eliminate them subsequently. This alone will be necessary to
 // accomplish it an alone time in design time.

 ShowMessage('Process Finish');
end;

--------------------------------------------------------------------------------
//  Call to recover the String from a language of table

procedure TForm1.Button3Click(Sender: TObject);
begin
 LangDbfComponent(Table1, // Data table
                  Form1,  // Form of the that will be obtained the data
                  'SP');  // Language that will catch in table. SP,IT,EN,DE,FR,PO
 end;

--------------------------------------------------------------------------------
// Call to add the data in a fichero.ini

procedure TForm1.Button1Click(Sender: TObject);
begin
 // Si incluimos la clasula una vez por idioma, nos los ir aadiendo
    secuencialmente en el fichero .Ini para traducir despues y poder llamar mas
    tarde desde la aplicacin el idioma deseado.

 IniStringComponent(Form1,      // Form del que obtendr los datos
                    'GLang',    // Nombre del fichero .INI (Lo dejar en el directorio \Windows
                    'English'); // Nombre del Idioma.
end;

Espaol
--------------------------------------------------------------------------------
  Esta Unit, contiene las funciones necesarias para obtener las strings de los
  componentes de un Form y escribirlas en una tabla en el campo de lenguaje
  indicado. Por defecto la tabla se llamar GLang.Dbf y se guardar en el
  directorio en que arranque la aplicacin, pero podemos incorporarla a un Alias
  en lugar de indicarle un directorio.

  En principio esta preparado para Espaol, Italiano, Ingles, Aleman, Frances y
  Portugues, pero basta con aadir o borrar campos de idioma en la tabla para que
  se adapte a nuestras necesidades.

  La tabla por defecto es .Dbf, pero si se desea basta con indicar una tabla
  con extensin .Db para que sea Paradox.

  Para generar la tabla inicial hay que llamar al procedimiento 'DbfStringComponent'
  una sola vez para cada form, y automticamente crear la tabla que le
  indiquemos en el idioma elegido. Si indicamos 'All' rellenar todos los campos.
  No hay lmite de cantidad de form incorporados a la tabla, basta con llamar a
  este procedimiento una vez por cada Form creado y aadir los datos del mismo.

  Tambin incorpora las funciones necesarias para recuperar las String almacenadas
  en la tabla y devolverlas a nuestro Form en el idioma que le indiquemos. Para
  ello basta con llamar al procedimiento 'LangDbfComponent'

  Como miscelanea se incluye la funcin de grabar las String en un fichero .Ini

Ejemplos de llamada:
--------------------------------------------------------------------------------
// Llamada para aadir los datos en Lang.dbf

procedure TForm1.Button2Click(Sender: TObject);
var
 Dir : String;
begin

 Dir := ExtractFilePath(ExpandFileName('Demo1.Exe'));
 if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';

 Table1.DatabaseName := Dir;
 Table1.TableName    := 'Lang.Dbf';
 ExisteTabla(Table1, Dir);

 Table1.Close;

 // Capturar los textos de los componentes
 DbfStringComponent(Table1, // Tabla de Datos
                    Form1,  // Form de donde se capturan los datos
                    Dir,    // DatabaseName, o directorio de la aplicacin
                    'ALL',  // Idiomas que rellenar en la tabla. SP,IT,EN,DE,FR,PO,(ALL Todos)
                    True,   // Grabar los Strings en Blanco
                    False;) // Sobreescribir las String existentes en la tabla.

 // A partir de aqu se puede llamar al procedimiento tantas veces como Form
 // se hayan creado con anterioridad, o bin crearlos, llamar a la funcin y
 // eliminarlos seguidamente. Esto solo ser necesario realizarlo una sola vez
 // en tiempo de diseo.

 ShowMessage('Proceso terminado');
end;

--------------------------------------------------------------------------------
// Llamada para recuperar los String desde un idioma de la tabla
procedure TForm1.Button3Click(Sender: TObject);
begin
 LangDbfComponent(Table1, // Tabla de datos
                  Form1,  // Form odel cual se obtendrn las string de los componentes
                  'SP');  // Lenguaje que se aadir a la tabla. SP,IT,EN,DE,FR,PO
end;

--------------------------------------------------------------------------------
// Llamada para aadir los datos en un fichero.ini
procedure TForm1.Button1Click(Sender: TObject);
begin
 // Si incluimos la clasula una vez por idioma, nos los ir aadiendo
    secuencialmente en el fichero .Ini para traducir despues y poder llamar mas
    tarde desde la aplicacin el idioma deseado.

 IniStringComponent(Form1,      // Form del que obtendr los datos
                    'GLang',    // Nombre del fichero .INI (Lo dejar en e directorio \Windows
                    'English'); // Nombre del Idioma.
end;

}
unit F_Lang;

interface

uses {$IFDEF WIN32} BDE,Windows, {ELSE} WinTypes,WinProcs,{$ENDIF}
     DbiErrs,DbiProcs,DbiTypes,DB,DBConsts,DBTables,Classes,SysUtils,Forms,
     Controls,Dialogs,IniFiles,FileCtrl,ExtCtrls,TabNotBk,Tabs,Outline,
     StdCtrls,DBCtrls,Menus,TypInfo,Messages,Graphics,DsgnIntf,Buttons;

  {Returns the value or content of a property if exists
   Devuelve el valor o contenido de una propiedad si esta existe}
  function  GetComponentProp(C: TComponent; Name: String): String;

  {Change the content of the property of the component
   Cambia el contenido de la propiedad del componente}
  procedure SetComponentProp(C: TComponent; const Name, Valor: String);

  {Says us if a component has the indicated property
   Nos dice si un componente tiene la propiedad indicada}
  function IfProperty(C: TComponent; Propiedad : String) : Boolean;

  {Watch exist table GLang, and if it does not create it
   Mira si existe la tabla Lang, y si no la crea}
  procedure IfExistsTable(var Table1 : TTable; Dir : String);

  {Record a record with the data of a property
   Graba un registro con los datos de una propiedad}
  procedure GrabaReg(var T: TTable; Lang : String; ReWrite : Boolean);

  {Read a record with the data of a property
   Lee un registro con los datos de una propiedad}
  procedure LeeReg(var T: TTable; Lang : String);

  {Add the data in GLang.dbf with the String of the components of a Form
   Aade los datos en Lang.dbf con las String de los componentes de un Form}
  procedure DbfStringComponent(var T : TTable;
                               Form : TForm;
                               Dir,
                               Lang : String;
                               Blancos,
                               ReWrite : Boolean);

  {Returns the String of the language selected for the form past
   Devuelve los String del idioma seleccionado para el form pasado}
  procedure LangDbfComponent(var T : TTable; Form : TForm; Lang : String);

var
 FicLang, Lenguage : String;

implementation

var
 S, sForm, sObj, sAll : String;

{Get property component if exists
 Devuelve el valor o contenido de una propiedad si esta existe}
function GetComponentProp(C: TComponent; Name: String): String;
var
 p:PPropInfo;
begin
 p := GetPropInfo(C.ClassInfo, Name);
 if Assigned(p) then Result := GetStrProp(C, p) else Result := '';
end;

{Set property component
 Cambia el contenido de la propiedad del componente}
procedure SetComponentProp(C: TComponent; const Name, Valor: String);
var
 p: PPropInfo;
begin
 if Valor = '' then Exit;
 p := GetPropInfo(C.ClassInfo, Name);
 if Assigned(p) then SetStrProp(C, p, Valor);
end;

{True if Exist property of component
 Devuelve True si esxiste la propiedad en el componente}
function IfProperty(C: TComponent; Propiedad : String) : Boolean;
begin
 Result := (C.Name <> '') and (GetPropInfo(C.ClassInfo, Propiedad) <> nil );
end;

{Mira si existe la tabla de Idioma, y si no la crea
 Watch exist table GLang, and if it does not create it}
procedure IfExistsTable(var Table1: TTable; Dir : String);
begin

 {Prove if exist table in the directorate or specified alias, and if it does not
  create it
  Comprueba si existe la tabla en el directorio especificado, y si no la crea}
 if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';

 if not FileExists(Dir + FicLang) then
  with Table1 do
   begin
   Close;
   DatabaseName := Dir;
   TableName    := FicLang;
   {The names of the fields and your length, they can be varied to will, always
    that in the calls to the procedures are observed the same names
    Los nombres de los campos y su longitud, pueden variarse a voluntad, siempre
    que en las llamadas a los procedimientos se respeten los mismos nombres}
   with FieldDefs do
    begin
    Clear;
    Add('Form', ftString, 30, False);
    Add('Objeto', ftString, 70, False);
    Add('SP', ftString, 125, False);
    Add('IT', ftString, 125, False);
    Add('EN', ftString, 125, False);
    Add('DE', ftString, 125, False);
    Add('FR', ftString, 125, False);
    Add('PO', ftString, 125, False);
    end;
  with IndexDefs do
    begin
    Clear;
    Add('Objeto', 'Objeto', []);
  end;
  CreateTable;
 end;
end;

{Record a record with the data of a property
 Graba un registro con los datos de una propiedad}
procedure GrabaReg(var T: TTable; Lang : String; ReWrite : Boolean);
begin
 sAll := sForm + '.' + sObj;
 with T do begin
  if not Active then Open;
  First;
  if not Locate('Objeto', sAll, [loPartialKey]) then Append;
  Edit;
  FieldByName('Form').AsString   := sForm;
  FieldByName('Objeto').AsString := sAll;
  if Rewrite then begin {ReWrite all string
                         Sobreescribir todas las String}
   if (Lang = 'SP') or (Lang = 'ALL')  then FieldByName('SP').AsString := s;
   if (Lang = 'EN') or (Lang = 'ALL')  then FieldByName('EN').AsString := s;
   if (Lang = 'IT') or (Lang = 'ALL')  then FieldByName('IT').AsString := s;
   if (Lang = 'DE') or (Lang = 'ALL')  then FieldByName('DE').AsString := s;
   if (Lang = 'FR') or (Lang = 'ALL')  then FieldByName('FR').AsString := s;
   if (Lang = 'PO') or (Lang = 'ALL')  then FieldByName('PO').AsString := s;
  end else begin {Alone writes when this in white
                  Solo escribe cuando esta en blanco}
   if ((Lang = 'SP') or (Lang = 'ALL')) and
      (Length(FieldByName('SP').AsString) = 0) then FieldByName('SP').AsString := s;
   if ((Lang = 'EN') or (Lang = 'ALL')) and
      (Length(FieldByName('EN').AsString) = 0) then FieldByName('EN').AsString := s;
   if ((Lang = 'IT') or (Lang = 'ALL')) and
      (Length(FieldByName('IT').AsString) = 0) then FieldByName('IT').AsString := s;
   if ((Lang = 'DE') or (Lang = 'ALL')) and
      (Length(FieldByName('DE').AsString) = 0) then FieldByName('DE').AsString := s;
   if ((Lang = 'FR') or (Lang = 'ALL')) and
      (Length(FieldByName('FR').AsString) = 0) then FieldByName('FR').AsString := s;
   if ((Lang = 'PO') or (Lang = 'ALL')) and
      (Length(FieldByName('PO').AsString) = 0) then FieldByName('PO').AsString := s;
  end;
  Post;
  Close;
 end;
end;

{Read a record with the data of a property
 Lee un registro con los datos de una propiedad}
procedure LeeReg(var T: TTable; Lang : String);
begin
 sAll := sForm + '.' + sObj;
 with T do begin
  if not Active then Open;
  First;
  if Locate('Objeto', sAll, [loPartialKey]) then begin
   if      Lang = 'SP'  then s := FieldByName('SP').AsString
   else if Lang = 'EN'  then s := FieldByName('EN').AsString
   else if Lang = 'IT'  then s := FieldByName('IT').AsString
   else if Lang = 'DE'  then s := FieldByName('DE').AsString
   else if Lang = 'FR'  then s := FieldByName('FR').AsString
   else if Lang = 'PO'  then s := FieldByName('PO').AsString
   else s := ''
  end else s := '';
 end;
end;

{Returns the String of the language selected for the form past
 Devuelve los String del idioma seleccionado para el form pasado}
procedure LangDbfComponent(var T : TTable; Form : TForm; Lang : String);
var
 C    : TComponent;
 j,i  : Integer;
begin

 { This procedure Obtains the properties from the components from a Form
  and seeks in table GLang.dbf your String in the asked language

  Table has several languages:
    EN: English; SP: Spanish; IT: Italian; DE: Aleman; FR: Frances; PO: Portugues;

  Example of call:
   LangDbfComponent(Table1,Form1, 'SP');
   LangDbfComponent(Table1,Form1, 'EN');
  ------------------------------------------------------------------------------
  Este procedimiento Obtiene las propiedades de los componentes de un Form
  y busca en la tabla Lang.dbf su String en el idioma preguntado

  La tabla tiene varios idiomas:
    SP: Espaol; EN: Ingles; IT: Italiano; DE: Aleman; FR: Frances; PO: Portugues;

   Ejemplo de llamada:
   LangDbfComponent(Table1,Form1, 'SP');
   LangDbfComponent(Table1,Form1, 'EN');
 }

 {We assure ourselves of the fact that the index is the waited
  Nos aseguramos de que el indice es el esperado}
 try
  T.Close;
  T.IndexName    := 'Objeto';
  T.Open;
 except
 end;

 {Properties obtainment and its String
  Obtencin de propiedades y sus String}
 try
  with Form do begin
   {Propertys of the Form}
   sForm := Name;

   {Caption of the Form}
   sObj  := Name + '.Caption'; {Objet and property}
   LeeReg(T,Lang); {Read property string}
   if (Length(s) > 0) then
    for j :=1 to Length(s) do if      s[j] = #21 then s[j] := #10
                              else if s[j] = #22 then s[j] := #13;
   Form.Caption := s;

   {Hint of the Form}
   sObj  := Name + '.Hint';
   LeeReg(T,Lang);
   if (Length(s) > 0) then
    for j:=1 to Length(s) do if      s[j] = #21 then s[j] := #10
                             else if s[j] = #22 then s[j] := #13;
   Form.Hint := s;

   {Propertys of the All component}
   for i := 0 to ComponentCount - 1 do begin
    {TeeChart make pointer exception
     TeeChart hace una excepcin de tipo puntero}
    if Pos('CHART',UpperCase(Components[i].Name)) = 0  then begin
     {Property Caption}
     if IfProperty(Components[i], 'Caption') then begin
      sObj := Components[i].Name + '.Caption';
      LeeReg(T,Lang);
      SetComponentProp(Components[i], 'Caption' , s);
     end;

     {Property Hint}
     if IfProperty(Components[i], 'Hint') then begin
      sObj := Components[i].Name + '.Hint';
      LeeReg(T,Lang);
      for j := 1 to Length(s) do
       if      s[j] = #21 then s[j] := #10
       else if s[j] = #22 then s[j] := #13;
      SetComponentProp(Components[i], 'Hint' , s);
     end;

     {Property Title}
     if IfProperty(Components[i], 'Title') then begin
      sObj := Components[i].Name + '.Title';
      LeeReg(T,Lang);
      SetComponentProp(Components[i], 'Title' , s);
     end;

     {Property DisplayLabel}
     if IfProperty(Components[i], 'DisplayLabel') then begin
      sObj := Components[i].Name + '.DisplayLabel';
      LeeReg(T,Lang);
      SetComponentProp(Components[i], 'DisplayLabel' , s);
     end;

     {Property Lines}
     if IfProperty(Components[i], 'Lines') then begin
      if Components[i] is TOutLine then
       for j := 0 to TOutLine(Components[i]).Lines.Count - 1 do begin
        sObj := Components[i].Name + '.' + IntToStr(j);
        LeeReg(T,Lang);
        TOutLine(Components[i]).Lines[j] := s;
       end
      else if Components[i] is TMemo then
            for j := 0 to TMemo(Components[i]).Lines.Count - 1 do begin
             sObj := Components[i].Name + '.' + IntToStr(j);
             LeeReg(T,Lang);
             TMemo(Components[i]).Lines[j] := s;
            end;
     end;

     {Property Items}
     if IfProperty(Components[i], 'Items') then begin
      if (Components[i] is TListBox) or
         (Components[i] is TComboBox) or
         (Components[i] is TDBListBox) or
         (Components[i] is TDBComboBox)
      then
       for j := 0 to TListBox(Components[i]).Items.Count-1 do begin
        sObj := Components[i].Name + '.' + IntToStr(j);
        LeeReg(T,Lang);
        TListBox(Components[i]).Items[j] := s;
       end
      else if (Components[i] is TRadioGroup) then
            for j := 0 to TRadioGroup(Components[i]).Items.Count-1 do begin
             sObj := Components[i].Name + '.' + IntToStr(j);
             LeeReg(T,Lang);
             TRadioGroup(Components[i]).Items[j] := s;
            end;
     end;

     {Property Pages}
     if IfProperty(Components[i], 'Pages') then begin
      if (Components[i] is TNotebook) then
       for j := 0 to TNotebook(Components[i]).Pages.Count-1 do begin
        sObj := Components[i].Name + '.' + IntToStr(j);
        LeeReg(T,Lang);
        TNotebook(Components[i]).Pages[j] := s;
       end
      else if (Components[i] is TTabbedNotebook)then
            for j := 0 to TTabbedNotebook(Components[i]).Pages.Count-1 do begin
             sObj := Components[i].Name + '.' + IntToStr(j);
             LeeReg(T,Lang);
             TTabbedNotebook(Components[i]).Pages[j] := s;
            end;
     end;

     {Property Tabs}
     if IfProperty(Components[i], 'Tabs') then begin
      if (Components[i] is TTabset) then
       for j := 0 to TTabset(Components[i]).Tabs.Count-1 do begin
        sObj := Components[i].Name + '.' + IntToStr(j);
        LeeReg(T,Lang);
        TTabset(Components[i]).Tabs[j] := s;
       end;
     end;
    end; {If is not teeChart Component
          Si no es TeeChart Component}
   end;  {for i := 0 to Form.ComponentCount - 1}
  end;   {with Form}
 finally
  T.Close;
 end; {try}
end;

procedure DbfStringComponent(var T : TTable; Form : TForm; Dir, Lang : String;
                             Blancos, ReWrite : Boolean);
var
 FI   : TIniFile;
 C    : TComponent;
 j,i  : Integer;
begin

 {This procedure adds to table Lang.dbf all the components that have String and
  your value. It is tables generator for power to accomplish applications in
  various languages.

  Table has several languages:
    EN: English; SP: Spanish; IT: Italian; ALL: Write what is same in all

  It will have to of be called alone in design time to create the languages table
  ------------------------------------------------------------------------------
  Este procedimiento aade a la tabla Lang.dbf todos los componentes que tienen
  String y su valor. Es el generador de recursos para intercionalizar las
  aplicaciones.
  La tabla tiene varios idiomas:
    SP: Espaol; EN: Ingles; IT: Italiano; DE: Aleman; FR: Frances;
    PO: Portugues; ALL: Escribe lo mismo en todos

   Ejemplo de llamada:
   DbfStringComponent(Copia_Dbf, 'Espaol');
   DbfStringComponent(Copia_Dbf, 'Ingles');

  Con esto nos aadira los textos en el idioma correspondiente con todos los
  String de los componentes, repetidos para cada objeto e idioma definido.
 }

 try
  T.Close;
  T.DatabaseName := Dir;
  T.TableName    := FicLang;
  T.IndexName    := 'Objeto';
  T.Open;
 except
 end;
 blancos := true;
 try
  with Form do begin
   {Propertys of the Form}
   sForm := Name;
   sAll  := Name + '.' + Name;

   // Caption of the Form
   sObj  := Name + '.Caption';
   S     := Caption;
   if Blancos or (Length(S) > 0) then
    for j:=1 to Length(S) do if S[j] = #10
                             then S[j] := #21
                             else if S[j] = #13
                                  then S[j] := #22;
   GrabaReg(T,Lang,Rewrite);

   // Hint of the Form
   sObj  := Name + '.Hint';
   S     := Hint;
   if Blancos or (Length(S) > 0) then
    for j:=1 to Length(S) do if S[j] = #10
                             then S[j] := #21
                             else if S[j] = #13
                                  then S[j] := #22;
   GrabaReg(T,Lang,Rewrite);

   {Propertys of the All component}
   for i := 0 to ComponentCount - 1 do begin
    C := Components[i];
    if (UpperCase(C.Name) = 'CHART1') or (UpperCase(C.Name) = 'CHART2') then
    C := Components[i + 1];

    {Property Caption}
    if IfProperty(C, 'Caption') then begin
     S := GetComponentProp(C,'Caption');
     if Blancos or (Length(s) > 0) then begin
      sObj := C.Name + '.Caption';
      GrabaReg(T,Lang,Rewrite);
     end;
    end;

    {Property Hint}
    if IfProperty(C, 'Hint') then begin
     S := GetComponentProp(C,'Hint');
     for j := 1 to Length(S) do if S[j] = #10
                                then S[j] := #21
                                else if S[j] = #13
                                     then S[j] := #22;
     if Blancos or (Length(s) > 0) then
      sObj := C.Name + '.Hint';
      GrabaReg(T,Lang,Rewrite);
    end;

    {Property Title}
    if IfProperty(C, 'Title') then begin
     s := GetComponentProp(C,'Title');
     if Blancos or (Length(s) > 0) then begin
      sObj := C.Name + '.Title';
      GrabaReg(T,Lang,Rewrite);
     end;
    end;

    {Property DisplayLabel}
    if IfProperty(C, 'DisplayLabel') then begin
     s := GetComponentProp(C,'DisplayLabel');
     if Blancos or (Length(s) > 0) then begin
      sObj := C.Name + '.DisplayLabel';
      GrabaReg(T,Lang,Rewrite);
     end;
    end;

    {Property Lines}
    if IfProperty(C, 'Lines') then begin
     if C is TOutLine then
      for j := 0 to TOutLine(C).Lines.Count - 1 do begin
       s    := TOutLine(C).Lines[j];
       sObj := C.Name + '.' + IntToStr(j);
       GrabaReg(T,Lang,Rewrite);
      end
     else if C is TMemo then
           for j := 0 to TMemo(C).Lines.Count - 1 do begin
            s    := TMemo(C).Lines[j];
            sObj := C.Name + '.' + IntToStr(j);
            GrabaReg(T,Lang,Rewrite);
           end;
    end;

    {Property Items}
    if IfProperty(C, 'Items') then begin
     if (C is TListBox) or (C is TComboBox) or (C is TDBListBox) or (C is TDBComboBox)
     then
          {for j := 0 to TListBox(C).Items.Count-1 do begin
            s    := TListBox(C).Items[j];
            sObj := C.Name + '.' + IntToStr(j);
            GrabaReg(T,Lang,Rewrite);
          end}
     else if (C is TRadioGroup)
          then for j := 0 to TRadioGroup(C).Items.Count-1 do begin
            s    := TRadioGroup(C).Items[j];
            sObj := C.Name + '.' + IntToStr(j);
            GrabaReg(T,Lang,Rewrite);
          end;
    end;

    {Property Pages}
    if IfProperty(C, 'Pages') then begin
     if (C is TNotebook) then
      for j := 0 to TNotebook(C).Pages.Count-1 do begin
       s    := TNotebook(C).Pages[j];
       sObj := C.Name + '.' + IntToStr(j);
       GrabaReg(T,Lang,Rewrite);
      end
     else if (C is TTabbedNotebook)then
           for j := 0 to TTabbedNotebook(C).Pages.Count-1 do begin
            s    := TTabbedNotebook(C).Pages[j];
            sObj := C.Name + '.' + IntToStr(j);
            GrabaReg(T,Lang,Rewrite);
           end;
    end;

    {Property Tabs}
    if IfProperty(C, 'Tabs') then begin
     if C is TTabset then
      for j := 0 to TTabset(C).Tabs.Count-1 do begin
       s    := TTabset(C).Tabs[j];
       sObj := C.Name + '.' + IntToStr(j);
       GrabaReg(T,Lang,Rewrite);
      end;
    end;

    {Property Filter}
    {if IfProperty(C, 'Filter') then begin
     s := GetComponentProp(C,'Filter');
     if (Blancos) or (Length(s) > 0) then begin
      sObj := C.Name + '.Filter';
      GrabaReg(T,Lang,ReWrite);
     end;
    end;}

    {Property CustomColors of TColorDialog}
    {if IfProperty(C, 'CustomColors') then begin
     for j := 0 to TColorDialog(C).CustomColors.Count-1 do
      s    := TColorDialog(C).CustomColors[j];
      sObj := C.Name + '.' + IntToStr(j);
      GrabaReg(T,Lang,ReWrite);
    end;}

   end; {for i := 0 to Form.ComponentCount - 1}
  end; { with Form }
 finally
  T.Close;
 end; {try}

end;

end.
